#!/bin/bash

#####################
# setting           #
#####################

devno=1
idealperf=0.98

dim_start_2d=512
dim_stop_2d=8192
dim_step_2d=512

dim_start_1d=20480
dim_stop_1d=409600
dim_step_1d=20480

./mublas_analyzer.py --devno=${devno} --routine=sgemv --trans=N --dimrange=${dim_start_2d}:${dim_stop_2d}:${dim_step_2d} --tbrange=8:1024:8 --tbdim=2 --idealperf=${idealperf} --process=all
./mublas_analyzer.py --devno=${devno} --routine=strmv --uplo=L --trans=N --diag=N --dimrange=${dim_start_2d}:${dim_stop_2d}:${dim_step_2d} --tbrange=8:1024:8 --tbdim=2 --idealperf=${idealperf} --process=all 
./mublas_analyzer.py --devno=${devno} --routine=sgemv --trans=T --dimrange=${dim_start_2d}:${dim_stop_2d}:${dim_step_2d} --tbrange=32:1024:32 --tbdim=1 --idealperf=${idealperf} --process=all 
./mublas_analyzer.py --devno=${devno} --routine=saxpy --dimrange=${dim_start_1d}:${dim_stop_1d}:${dim_step_1d} --tbrange=8:1024:8 --tbdim=1 --idealperf=${idealperf} --process=all 

./mublas_analyzer.py --devno=${devno} --routine=dgemv --trans=N --dimrange=${dim_start_2d}:${dim_stop_2d}:${dim_step_2d} --tbrange=8:1024:8 --tbdim=2 --idealperf=${idealperf} --process=all 
./mublas_analyzer.py --devno=${devno} --routine=dtrmv --uplo=L --trans=N --diag=N --dimrange=${dim_start_2d}:${dim_stop_2d}:${dim_step_2d} --tbrange=8:1024:8 --tbdim=2 --idealperf=${idealperf} --process=all 
./mublas_analyzer.py --devno=${devno} --routine=dgemv --trans=T --dimrange=${dim_start_2d}:${dim_stop_2d}:${dim_step_2d} --tbrange=32:1024:32 --tbdim=1 --idealperf=${idealperf} --process=all 
./mublas_analyzer.py --devno=${devno} --routine=daxpy --dimrange=${dim_start_1d}:${dim_stop_1d}:${dim_step_1d} --tbrange=8:1024:8 --tbdim=1 --idealperf=${idealperf} --process=all 

./mublas_analyzer.py --devno=${devno} --routine=cgemv --trans=N --dimrange=${dim_start_2d}:${dim_stop_2d}:${dim_step_2d} --tbrange=8:1024:8 --tbdim=2 --idealperf=${idealperf} --process=all 
./mublas_analyzer.py --devno=${devno} --routine=ctrmv --uplo=L --trans=N --diag=N --dimrange=${dim_start_2d}:${dim_stop_2d}:${dim_step_2d} --tbrange=8:1024:8 --tbdim=2 --idealperf=${idealperf} --process=all 
./mublas_analyzer.py --devno=${devno} --routine=cgemv --trans=T --dimrange=${dim_start_2d}:${dim_stop_2d}:${dim_step_2d} --tbrange=32:1024:32 --tbdim=1 --idealperf=${idealperf} --process=all 
./mublas_analyzer.py --devno=${devno} --routine=caxpy --dimrange=${dim_start_1d}:${dim_stop_1d}:${dim_step_1d} --tbrange=8:1024:8 --tbdim=1 --idealperf=${idealperf} --process=all 

./mublas_analyzer.py --devno=${devno} --routine=zgemv --trans=N --dimrange=${dim_start_2d}:${dim_stop_2d}:${dim_step_2d} --tbrange=8:1024:8 --tbdim=2 --idealperf=${idealperf} --process=all 
./mublas_analyzer.py --devno=${devno} --routine=ztrmv --uplo=L --trans=N --diag=N --dimrange=${dim_start_2d}:${dim_stop_2d}:${dim_step_2d} --tbrange=8:1024:8 --tbdim=2 --idealperf=${idealperf} --process=all 
./mublas_analyzer.py --devno=${devno} --routine=zgemv --trans=T --dimrange=${dim_start_2d}:${dim_stop_2d}:${dim_step_2d} --tbrange=32:1024:32 --tbdim=1 --idealperf=${idealperf} --process=all 
./mublas_analyzer.py --devno=${devno} --routine=zaxpy --dimrange=${dim_start_1d}:${dim_stop_1d}:${dim_step_1d} --tbrange=8:1024:8 --tbdim=1 --idealperf=${idealperf} --process=all 
