#!/usr/bin/env python
#coding:utf-8

##################################################
# MUBLAS Analyzer ver.0.95
##################################################
debug = 0

##############################################################
# header
##############################################################
import os
import sys
import string

##############################################################
# function
##############################################################
def do (command):
	if (debug == 1):
		print "[cmd] " + command
	else:
		os.system (command)

def print_msg (msg):
	print ">>> mublas_gen_recipe.py <<< " + msg

##############################################################
# Gen File
##############################################################

def gen_file (l):
#	print l
	text = ''

	if (l[0] == '%%'):
		command = 'echo "/* incl file */" > mublas_' + l[1].lower() + '.incl'
		do (command)
		command = 'echo "/* def file */" > mublas_' + l[1].lower() + '.def'
		do (command)
	else:
		if (l[0] == 'C'):
			filename = "mublas_" + l[5].lower() + ".incl"
		if (l[0] == 'D'):
			filename = "mublas_" + l[5].lower() + ".def"

		# arch (cc)
		if (l[3] != ''):
#			if (l[3][-1:] == 'x'):
#				text += "if (" +  str(int(l[3][-2:-1])*100) + " <= mh->cc && mh->cc < " + str((int(l[3][-2:-1])+1)*100) + ") {\n"
#			else:
			text += "if (mh->cc == " + l[3] + ") {\n"

		# prec
		if (l[4] != ''):
			if (l[4][0] == '!'):
				text += "#if !defined (PREC_" + l[4].replace('!','') + ")\n"
			else:
				text += "#if defined (PREC_" + l[4] + ")\n"

		# ----------------------
		# content
		if (l[0] == 'C'):
			text += "mh->" + l[1] + ' = ' + l[2] + ';\n'
		if (l[0] == 'D'):
			text += "#define\t" + l[1] + '_' + l[5] + '\t' + l[2] + '\n'
		# ----------------------

		# prec
		if (l[4] != ''):
			text += "#endif\n"
		# arch
		if (l[3] != ''):
			text += "}\n"

		command = 'echo "' + text + '" >> ' + filename
		do (command)

##############################################################
# main
##############################################################
def main ():
	print_msg ("removing previous *.incl and *.def files...")
	cmd = "rm *.incl"
	do (cmd)
	cmd = "rm *.def"
	do (cmd)
	print_msg ("creating new *.incl and *.def files...")

	f = open ("mublas_recipe.csv")
	lines = f.readlines ()
	f.close ()
	for line in lines:
		line = line.rstrip()
		l = line.split(',')
		if (l[0][0:1] != '#' and len(l[0]) != 0):
			gen_file (l)

	print_msg ("done")

##############################################################
# main
##############################################################
if __name__ == "__main__":
	main ()

