set term postscript eps enhanced color

set style line 11 lt 1 lw 0.5  ps 0.5 pt 6 lc rgb "#CC3300" # red
set style line 12 lt 2 lw 0.5  ps 0.5 pt 5 lc rgb "#CC3300" # red
set style line 13 lt 3 lw 0.5  ps 0.5 pt 4 lc rgb "#CC3300" # red
set style line 14 lt 4 lw 0.5  ps 0.5 pt 3 lc rgb "#CC3300" # red
set style line 21 lt 1 lw 0.5  ps 0.5 pt 2 lc rgb "#009900" # green
set style line 22 lt 2 lw 0.5  ps 0.5 pt 2 lc rgb "#009900" # green
set style line 31 lt 1 lw 0.5  ps 0.5 pt 8 lc rgb "#3399FF" # blue
set style line 32 lt 2 lw 0.5  ps 0.5 pt 7 lc rgb "#3399FF" # blue
set style line 33 lt 3 lw 0.5  ps 0.5 pt 9 lc rgb "#3399FF" # blue
set style line 34 lt 4 lw 0.5  ps 0.5 pt 1 lc rgb "#3399FF" # blue

##################################################################################################################
# Settings
##################################################################################################################

set key right bottom
set grid
set size 0.55,0.6
set yrange [0:200]
#set ytics (100,120,140,160,180)
set xlabel "Problem Size (M=N)" offset 0,0.5
set ylabel "GB/s" offset 1.5,0

##################################################################################################################
# plot
##################################################################################################################

set xrange [0:10000]

set title "SGEMV-N (GeForce GTX980)" offset 0,-0.5
set output "fig_testing_sgemv_n_gtx980.eps"
plot \
"_testing_mublas_sgemv_n_gtx980.dat" index 0 using 2:6 title "MUBLAS 1.5.14" w linespoints ls 11,\
"_testing_cublas_sgemv_n_gtx980.dat" index 0 using 2:6 title "CUBLAS 7.5RC" w linespoints ls 21,\
"_testing_kblas_sgemv_n_gtx980.dat" index 0 using 2:6 title "KBLAS 1.3-beta" w linespoints ls 31

set title "SGEMV-T (GeForce GTX980)" offset 0,-0.5
set output "fig_testing_sgemv_t_gtx980.eps"
plot \
"_testing_mublas_sgemv_t_gtx980.dat" index 0 using 2:6 title "MUBLAS 1.5.14" w linespoints ls 11,\
"_testing_cublas_sgemv_t_gtx980.dat" index 0 using 2:6 title "CUBLAS 7.5RC" w linespoints ls 21,\
"_testing_kblas_sgemv_t_gtx980.dat" index 0 using 2:6 title "KBLAS 1.3-beta" w linespoints ls 31

set title "STRMV-L (GeForce GTX980)" offset 0,-0.5
set output "fig_testing_strmv_lnn_gtx980.eps"
plot \
"_testing_mublas_strmv_lnn_gtx980.dat" index 0 using 2:6 title "MUBLAS 1.5.14" w linespoints ls 11,\
"_testing_cublas_strmv_lnn_gtx980.dat" index 0 using 2:6 title "CUBLAS 7.5RC" w linespoints ls 21

