set term postscript eps enhanced color

set style line 11 lt 1 lw 1.0  ps 0.5 pt 6 lc rgb "#CC3300" # red
set style line 12 lt 2 lw 1.0  ps 0.5 pt 5 lc rgb "#CC3300" # red
set style line 13 lt 3 lw 1.0  ps 0.5 pt 4 lc rgb "#CC3300" # red
set style line 14 lt 4 lw 1.0  ps 0.5 pt 3 lc rgb "#CC3300" # red
set style line 21 lt 1 lw 1.0  ps 0.5 pt 2 lc rgb "#009900" # green
set style line 22 lt 2 lw 1.0  ps 0.5 pt 2 lc rgb "#009900" # green
set style line 31 lt 1 lw 1.0  ps 0.5 pt 8 lc rgb "#3399FF" # blue
set style line 32 lt 2 lw 1.0  ps 0.5 pt 7 lc rgb "#3399FF" # blue
set style line 33 lt 3 lw 1.0  ps 0.5 pt 9 lc rgb "#3399FF" # blue
set style line 34 lt 4 lw 1.0  ps 0.5 pt 1 lc rgb "#3399FF" # blue
set style line 41 lt 4 lw 1.0  ps 0.5 pt 1 lc rgb "#33FFFF" # blue

set style line 91 lt 1 lw 1.0  ps 0.5 pt 1 lc rgb "#CC0000" # red
set style line 92 lt 2 lw 1.0  ps 0.5 pt 2 lc rgb "#FF6633" # red
set style line 93 lt 3 lw 1.0  ps 0.5 pt 3 lc rgb "#0066CC" # blue
set style line 94 lt 4 lw 1.0  ps 0.5 pt 4 lc rgb "#33CCFF" # blue
set style line 95 lt 1 lw 1.0  ps 0.5 pt 5 lc rgb "#FF6600" #
set style line 96 lt 2 lw 1.0  ps 0.5 pt 6 lc rgb "#FFCC33" #
set style line 97 lt 3 lw 1.0  ps 0.5 pt 7 lc rgb "#00CC66" #
set style line 98 lt 4 lw 1.0  ps 0.5 pt 8 lc rgb "#66FFCC" #

##################################################################################################################
# Settings
##################################################################################################################

set key right bottom
set grid
set size 0.55,0.6
set xlabel "Problem Size (M=N)" offset 0,0.5
set ylabel "GB/s" offset 1.5,0

##################################################################################################################
# plot
##################################################################################################################

set xrange [0:10000]

set title "SGEMV-N (Tesla K20c)" offset 0,-0.5
set output "fig_testing_sgemv_n_k20c.eps"
plot \
"_testing_mublas_sgemv_n_k20c.dat" using 2:6 title "MUBLAS 1.5.14" w linespoints ls 11,\
"_testing_cublas_sgemv_n_k20c.dat" using 2:6 title "CUBLAS 7.5RC" w linespoints ls 21,\
"_testing_kblas_sgemv_n_k20c.dat" using 2:6 title "KBLAS 1.3-beta" w linespoints ls 31

set title "SGEMV-T (Tesla K20c)" offset 0,-0.5
set output "fig_testing_sgemv_t_k20c.eps"
plot \
"_testing_mublas_sgemv_t_k20c.dat" using 2:6 title "MUBLAS 1.5.14" w linespoints ls 11,\
"_testing_cublas_sgemv_t_k20c.dat" using 2:6 title "CUBLAS 7.5RC" w linespoints ls 21,\
"_testing_kblas_sgemv_t_k20c.dat" using 2:6 title "KBLAS 1.3-beta" w linespoints ls 31

set title "STRMV-L (Tesla K20c)" offset 0,-0.5
set output "fig_testing_strmv_l_k20c.eps"
plot \
"_testing_mublas_strmv_lnn_k20c.dat" using 2:6 title "MUBLAS 1.5.14" w linespoints ls 11,\
"_testing_cublas_strmv_lnn_k20c.dat" using 2:6 title "CUBLAS 7.5RC" w linespoints ls 21

set title "MUBLAS xGEMV-N (Tesla K20c)" offset 0,-0.5
set output "fig_testing_xgemv_n_k20c_1.eps"
plot \
"_testing_mublas_sgemv_n_k20c.dat" using 2:6 title "Single" w linespoints ls 91,\
"_testing_mublas_cgemv_n_k20c.dat" using 2:6 title "Single Complex" w linespoints ls 92,\
"_testing_mublas_dgemv_n_k20c.dat" using 2:6 title "Double" w linespoints ls 93,\
"_testing_mublas_zgemv_n_k20c.dat" using 2:6 title "Double Complex" w linespoints ls 94

set title "MUBLAS xGEMV-N (Tesla K20c)" offset 0,-0.5
set output "fig_testing_xgemv_n_k20c_2.eps"
plot \
"_testing_mublas_wgemv_n_k20c.dat" using 2:6 title "Double-Double" w linespoints ls 95,\
"_testing_mublas_ugemv_n_k20c.dat" using 2:6 title "Double-Double Complex" w linespoints ls 96,\
"_testing_mublas_vgemv_n_k20c.dat" using 2:6 title "Double-Float Complex" w linespoints ls 97,\
"_testing_mublas_bgemv_n_k20c.dat" using 2:6 title "Double-Float" w linespoints ls 98



