#!/usr/bin/env python
#coding:utf-8

##################################################
# MUBLAS Analyzer ver.1.4.28
##################################################

debug = 0
routine = "strmv"
devno = 0

##############################################################
# header
##############################################################
import os
import sys
import csv
import string
import operator
import argparse
import numpy
import math
import subprocess

##############################################################
# functions:
##############################################################
def ceiling (n, c):
	return math.ceil (n/c) * c

def import_csv_file (file_in):
	with open (file_in, 'r') as dat:
		csv_dat = list(csv.reader(dat, delimiter='\t'))
	for row in range(len(csv_dat)):
		for cell in range(len(csv_dat[row])):
			try:
				csv_dat[row][cell] = float(csv_dat[row][cell])
			except:
				pass
	return csv_dat

def export_csv_file (csv_dat, file_ou):
	cmd = 'echo "" > ' + file_ou
	do (cmd)
	for row in csv_dat:
		row = [str(text) for text in row]
		cmd = 'echo "' + '\t'.join(row) + '" >> ' + file_ou
		do (cmd)

def sort_csv_dat(csv_dat, key):
	header = csv_dat[0]
	body = sorted (csv_dat[1:], key=operator.itemgetter(header.index(key)), reverse=True)
	body.insert (0, header)
	return body

def list_to_str (list_dat):
	dat = ""
	for x in list_dat:
		dat += str(x) + "\t"
	return dat

def do (command):
	if (debug == 1):
		print "[cmd] " + command
	elif (debug == 2):
		print "[cmd] " + command
		os.system (command)
	else:
		os.system (command)

def debug_msg (msg):
	print ("< mublas_analyzer > " + msg)

##############################################################
# main
##############################################################
def main ():
	argvs = sys.argv
	argc = len (argvs)

	debug_msg ("-----------------------")
	file_io = "at_mublas_" + routine + ".dat"
	cmd = "./testing_mublas_" + routine + " --devno=" + str(devno) + " --mode=t --nodisp=1 --range=32:32:1 > " + file_io + "_"
	do (cmd)
	cmd = 'echo "ID\tTx\tTy\tTy/Tx\tWrpOcp\tBlkOcp\tGrdOcp\tdimEval" > ' + file_io
	do (cmd)

	f = open (file_io + "_")
	lines = f.readlines ()
	f.close ()
	for line in lines:
		line = line.rstrip()
		if (line[0:4] == '[AT]'):
			line = line.replace('[AT]', '')
			cmd = 'echo "' + line + '" >> ' + file_io
			do (cmd)

	csv_dat = import_csv_file (file_io)
	csv_sorted = sort_csv_dat (csv_dat, 'Ty/Tx')
	file_ou = "at_mublas_" + routine + "_ou.dat"
	cmd = 'echo "%" > ' + file_ou
	do (cmd)
	for x in csv_sorted[1:]:
		if (x[7] < 15000):
			cmd = './testing_mublas_' + routine + ' --devno=' + str(devno) + ' --mode=p --nodisp=1 --range=' + str(x[7]) + ':' + str(x[7]) + ':1' + ' --tx=' + str(x[1]) + ' --ty=' + str(x[2]) + ' >> ' + file_ou
			do (cmd)
	export_csv_file (csv_sorted, file_io)
	cmd = 'rm ' + file_io + "_"
	do (cmd)

##############################################################
# main
##############################################################
if __name__ == "__main__":
	main ()

