#ifndef PREC_B_H
#define PREC_B_H

#ifdef PREC_B

#define FPADDCOUNT 1
#define FPMULCOUNT 1
#define FPMADCOUNT 2

// TYPE
#define CUBLAS_TYPE double
#define CUBLAS_BASETYPE CUBLAS_TYPE
#define CUBLAS_ZERO 0.
#define CUBLAS_ONE 1.
#define CUBLAS_NEGONE -1.
#define CBLAS_TYPE double
#define CBLAS_BASETYPE CBLAS_TYPE
#define CBLAS_ZERO 0.
#define CBLAS_ONE 1.
#define CBLAS_NEGONE -1.
#define MBLAS_TYPE qd_real
#define MBLAS_BASETYPE MBLAS_TYPE
#define MBLAS_ZERO qd_real(0.)
#define MBLAS_ONE qd_real(1.)
#define MBLAS_NEGONE qd_real(-1.)

#if defined (MUBLAS)
#define GPU_TYPE cudfreal
#elif defined (CUBLAS)
#define GPU_TYPE 
#elif defined (KBLAS)
#define GPU_TYPE
#elif defined (MAGMA)
#define GPU_TYPE
#elif defined (CULA)
#define GPU_TYPE
#elif defined (ASPEN)
#define GPU_TYPE cudfreal
#endif
#define MAKE_GPU_TYPE(x) double_to_cudfreal(x)

// COPY
#define CBLAS_COPY cblas_dcopy
#define MBLAS_COPY Rcopy
#define MUBLAS_COPY mublasBcopy
#define CUBLAS_COPY cublasDcopy
#define MAGMA_COPY 
#define CULA_COPY
#define KBLAS_COPY 

// SCAL
#define CBLAS_SCAL cblas_dscal
#define MBLAS_SCAL Rscal
#define MUBLAS_SCAL mublasBscal
#define CUBLAS_SCAL cublasDscal
#define MAGMA_SCAL 
#define CULA_SCAL
#define KBLAS_SCAL 

// AXPY
#define CBLAS_AXPY cblas_daxpy
#define MBLAS_AXPY Raxpy
#define MUBLAS_AXPY mublasBaxpy
#define CUBLAS_AXPY cublasDaxpy
#define MAGMA_AXPY 
#define CULA_AXPY
#define KBLAS_AXPY 

// DOT
#define CBLAS_DOT cblas_ddot
#define MBLAS_DOT Rdot
#define MUBLAS_DOT mublasBdot
#define CUBLAS_DOT cublasDdot
#define MAGMA_DOT 
#define CULA_DOT
#define KBLAS_DOT 

// GEMV
#define MUBLAS_GEMV_MGPU_ASYNC mublasBgemvMgpuAsync
#define MUBLAS_GEMV_MGPU mublasBgemvMgpu
#define MUBLAS_GEMV_MGPU_V2_ASYNC mublasBgemvMgpuV2Async
#define MUBLAS_GEMV_MGPU_V2 mublasBgemvMgpuV2
#define CBLAS_GEMV cblas_dgemv
#define MBLAS_GEMV Rgemv
#define MUBLAS_GEMV mublasBgemv
#define CUBLAS_GEMV cublasDgemv
#define MAGMA_GEMV 
#define CULA_GEMV
#define KBLAS_GEMV 
#define ASPEN_GEMV ASPEN_bgemv

// SYMV
#define CBLAS_SYMV cblas_dsymv
#define MBLAS_SYMV Rsymv
#define MUBLAS_SYMV mublasBsymv
#define CUBLAS_SYMV cublasDsymv
#define MAGMA_SYMV 
#define CULA_SYMV
#define KBLAS_SYMV 
#define ASPEN_SYMV ASPEN_bsymv

// TRMV
#define CBLAS_TRMV cblas_dtrmv
#define MBLAS_TRMV Rtrmv
#define MUBLAS_TRMV mublasBtrmv
#define CUBLAS_TRMV cublasDtrmv
#define MAGMA_TRMV 
#define CULA_TRMV 
#define KBLAS_TRMV 
#define ASPEN_TRMV 

// GER
#define CBLAS_GER cblas_dger
#define MBLAS_GER Rger
#define MUBLAS_GER 
#define CUBLAS_GER cublasDger
#define MAGMA_GER
#define CULA_GER 
#define KBLAS_GER 
#define ASPEN_GER 

// GEMM
#define CBLAS_GEMM cblas_dgemm
#define MBLAS_GEMM Rgemm
#define MUBLAS_GEMM mublasBgemm
#define CUBLAS_GEMM cublasDgemm
#define MAGMA_GEMM 
#define CULA_GEMM
#define KBLAS_GEMM 
#define ASPEN_GEMM 


// NRM2
#define CBLAS_NRM cblas_dnrm2
#define MBLAS_NRM Rnrm2
#define CUBLAS_NRM cublasDnrm2

#endif

#endif
