#ifndef PREC_V_H
#define PREC_V_H

#ifdef PREC_V

#define FPADDCOUNT 2
#define FPMULCOUNT 6
#define FPMADCOUNT 8

// TYPE
#define CUBLAS_TYPE cuDoubleComplex
#define CUBLAS_BASETYPE double
#define CUBLAS_ZERO make_cuDoubleComplex(0.,0.)
#define CUBLAS_ONE make_cuDoubleComplex(1.,0.)
#define CUBLAS_NEGONE make_cuDoubleComplex(-1.,0.)
#define CBLAS_TYPE doublecomplex
#define CBLAS_BASETYPE double
#define CBLAS_ZERO {0.,0.}
#define CBLAS_ONE {1.,0.}
#define CBLAS_NEGONE {-1.,0.}
#define MBLAS_TYPE qd_complex
#define MBLAS_BASETYPE qd_real
#define MBLAS_ZERO qd_complex(qd_real(0.),qd_real(0.))
#define MBLAS_ONE qd_complex(qd_real(1.),qd_real(0.))
#define MBLAS_NEGONE qd_complex(qd_real(-1.),qd_real(0.))

#if defined (MUBLAS)
#define GPU_TYPE cudfcomplex
#elif defined (CUBLAS)
#define GPU_TYPE 
#elif defined (KBLAS)
#define GPU_TYPE
#elif defined (MAGMA)
#define GPU_TYPE
#elif defined (CULA)
#define GPU_TYPE
#elif defined (ASPEN)
#define GPU_TYPE cudfcomplex
#endif
#define MAKE_GPU_TYPE(r,i) make_cudfcomplex(double_to_cudfreal(r),double_to_cudfreal(i))

// COPY
#define CBLAS_COPY cblas_zcopy
#define MBLAS_COPY Ccopy
#define MUBLAS_COPY mublasVcopy
#define CUBLAS_COPY cublasZcopy
#define MAGMA_COPY
#define CULA_COPY
#define KBLAS_COPY

// SCAL
#define CBLAS_SCAL cblas_zscal
#define MBLAS_SCAL Cscal
#define MUBLAS_SCAL mublasVscal
#define CUBLAS_SCAL cublasZscal
#define MAGMA_SCAL 
#define CULA_SCAL 
#define KBLAS_SCAL

// AXPY
#define CBLAS_AXPY cblas_zaxpy
#define MBLAS_AXPY Caxpy
#define MUBLAS_AXPY mublasVaxpy
#define CUBLAS_AXPY cublasZaxpy
#define MAGMA_AXPY
#define CULA_AXPY
#define KBLAS_AXPY

// DOTU
#define CBLAS_DOTU cblas_zdotu
#define MBLAS_DOTU Cdotu
#define MUBLAS_DOTU mublasVdotu
#define CUBLAS_DOTU cublasZdotu
#define MAGMA_DOTU
#define CULA_DOTU
#define KBLAS_DOTU

// GEMV
#define MUBLAS_GEMV_MGPU_ASYNC mublasVgemvMgpuAsync
#define MUBLAS_GEMV_MGPU mublasVgemvMgpu
#define MUBLAS_GEMV_MGPU_V2_ASYNC mublasVgemvMgpuV2Async
#define MUBLAS_GEMV_MGPU_V2 mublasVgemvMgpuV2
#define CBLAS_GEMV cblas_zgemv
#define MBLAS_GEMV Cgemv
#define MUBLAS_GEMV mublasVgemv
#define CUBLAS_GEMV cublasZgemv
#define MAGMA_GEMV
#define CULA_GEMV
#define KBLAS_GEMV
#define ASPEN_GEMV ASPEN_vgemv

// HEMV
#define CBLAS_HEMV cblas_zhemv
#define MBLAS_HEMV Chemv
#define MUBLAS_HEMV mublasVhemv
#define CUBLAS_HEMV cublasZhemv
#define MAGMA_HEMV 
#define CULA_HEMV
#define KBLAS_HEMV 
#define ASPEN_HEMV ASPEN_vhemv

// TRMV
#define CBLAS_TRMV cblas_ztrmv
#define MBLAS_TRMV Ctrmv
#define MUBLAS_TRMV mublasVtrmv
#define CUBLAS_TRMV cublasZtrmv
#define MAGMA_TRMV 
#define CULA_TRMV 
#define KBLAS_TRMV 
#define ASPEN_TRMV 

// GER
#define CBLAS_GER cblas_zger
#define MBLAS_GER Cger
#define MUBLAS_GER 
#define CUBLAS_GER cublasZger
#define MAGMA_GER
#define CULA_GER 
#define KBLAS_GER 
#define ASPEN_GER 

// GEMM
#define CBLAS_GEMM cblas_zgemm
#define MBLAS_GEMM Cgemm
#define MUBLAS_GEMM mublasVgemm
#define CUBLAS_GEMM cublasZgemm
#define MAGMA_GEMM
#define CULA_GEMM
#define KBLAS_GEMM 
#define ASPEN_GEMM 

// NRM2
#define CBLAS_NRM cblas_dznrm2
#define MBLAS_NRM RCnrm2
#define CUBLAS_NRM cublasDznrm2

#endif

#endif
